]> sipb.mit.edu Git - ikiwiki.git/blobdiff - IkiWiki/Plugin/mdwn.pm
avoid uninitialised value
[ikiwiki.git] / IkiWiki / Plugin / mdwn.pm
index 8e037f5de192377018cd81c8f12a10c89d76d9bf..11f3f0137627643fe285e0464b59b2e0086b3f88 100644 (file)
@@ -4,38 +4,66 @@ package IkiWiki::Plugin::mdwn;
 
 use warnings;
 use strict;
-use IkiWiki;
+use IkiWiki 2.00;
 
 sub import { #{{{
-       IkiWiki::hook(type => "htmlize", id => "mdwn", call => \&htmlize);
+       hook(type => "htmlize", id => "mdwn", call => \&htmlize);
 } # }}}
 
-my $markdown_loaded=0;
-sub htmlize ($) { #{{{
-       my $content = shift;
+my $markdown_sub;
+sub htmlize (@) { #{{{
+       my %params=@_;
+       my $content = $params{content};
 
-       if (! $markdown_loaded) {
-               # Note: This hack to make markdown run as a proper perl
-               # module. A proper perl module is available in Debian
-               # for markdown, but not upstream yet.
+       if (! defined $markdown_sub) {
+               # Markdown is forked and splintered upstream and can be
+               # available in a variety of forms. Support them all.
                no warnings 'once';
                $blosxom::version="is a proper perl module too much to ask?";
                use warnings 'all';
 
-               eval q{use Markdown};
-               if ($@) {
-                       do "/usr/bin/markdown" ||
-                               IkiWiki::error("failed to load Markdown.pm perl module ($@) or /usr/bin/markdown ($!)");
+               if (exists $config{multimarkdown} && $config{multimarkdown}) {
+                       eval q{use Text::MultiMarkdown};
+                       if ($@) {
+                               error(gettext("multimarkdown is enabled, but Text::MultiMarkdown is not installed"));
+                       }
+                       $markdown_sub=sub {
+                               Text::MultiMarkdown::markdown(shift, {use_metadata => 0});
+                       }
                }
-               $markdown_loaded=1;
+               else {
+                       eval q{use Text::Markdown};
+                       if (! $@) {
+                               if (Text::Markdown->can('markdown')) {
+                                       $markdown_sub=\&Text::Markdown::markdown;
+                               }
+                               else {
+                                       $markdown_sub=\&Text::Markdown::Markdown;
+                               }
+                       }
+                       else {
+                               eval q{use Markdown};
+                               if (! $@) {
+                                       $markdown_sub=\&Markdown::Markdown;
+                               }
+                               else {
+                                       do "/usr/bin/markdown" ||
+                                               error(sprintf(gettext("failed to load Markdown.pm perl module (%s) or /usr/bin/markdown (%s)"), $@, $!));
+                                       $markdown_sub=\&Markdown::Markdown;
+                               }
+                       }
+               }
+               
                require Encode;
        }
        
        # Workaround for perl bug (#376329)
        $content=Encode::encode_utf8($content);
-       $content=Encode::encode_utf8($content);
-       $content=Markdown::Markdown($content);
-       $content=Encode::decode_utf8($content);
+       eval {$content=&$markdown_sub($content)};
+       if ($@) {
+               eval {$content=&$markdown_sub($content)};
+               print STDERR $@ if $@;
+       }
        $content=Encode::decode_utf8($content);
 
        return $content;